cccc  Calculates subtraction
      subroutine cs_subt(p,out)
      implicit none
      double precision q01,q02,out1,out2
      double precision alphaEM,phot1,phot2
      double precision out
      integer p,i,j,h1,h2
      double precision f1ar(4),f2ar(4),outt(8)
      double precision garr1(-6:6),garr2(-6:6)
      
      include 'mp.f'
      include 'pi.f'
      include 'x.f'
      include 'xb.f'
      include 'diss.f'
      include 'vars.f'
      include 'mom.f'
      include 'ewpars.f'
      include 'proc.f'
      include 'norm.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'gmatrices.f'
      include 'NSF.f'
      include 'kmu.f'
      include 'ewsf.f'
      
      call evolvePDFphoton(x1,mx*kmu,garr1,phot1)
      call evolvePDFphoton(x2,mx*kmu,garr2,phot2)

      if(p.eq.1)then
         q01=1d0
         q02=1d0
         call pqg_conv(x1,mx,q01,out1)
         out1=out1*alphaEM(mx**2*kmu**2)
     &        /2d0/pi*dlog(mx**2*kmu**2/q01**2)
         call pqg_conv(x2,mx,q02,out2)
         out2=out2*alphaEM(mx**2*kmu**2)
     &        /2d0/pi*dlog(mx**2*kmu**2/q02**2)
      endif
      
      
      do i=1,4
         outt(i)=0d0
         do h1=1,2
            do h2=1,2
               outt(i)=outt(i)+cdabs(zsubt(p,i,h1,h2)
     &              +zsubt(p,i+4,h1,h2))**2/4d0/3d0
            enddo
         enddo
      enddo
      
ccccc DY subtrated

      outt(1)=outt(1)*(out1*(garr2(-2)+garr2(-4))
     &     +(garr1(2)+garr1(4))*out2)*eq(2)**2
      outt(2)=outt(2)*(out1*(garr2(-1)+garr2(-3)+garr2(-5))
     &     +(garr1(1)+garr1(3)+garr1(5))*out2)*eq(1)**2
      outt(3)=outt(3)*(out1*(garr2(2)+garr2(4))
     &     +(garr1(-2)+garr1(-4))*out2)*eq(2)**2
      outt(4)=outt(4)*(out1*(garr2(1)+garr2(3)+garr2(5))
     &     +(garr1(-1)+garr1(-3)+garr1(-5))*out2)*eq(1)**2

      out=0d0
      do i=1,4
         out=out+outt(i)
      enddo
      
      out=out/x1/x2
      
      return
      end

      subroutine pqg_conv(x,q,q0,out)
      implicit none
      double precision x,q,q0,out
      double precision zmin,zmax,z,lz,lzmin,lzmax,lhz
      double precision sum,wt,phot
      double precision garr(-6:6)
      integer i,itot

      itot=50

      zmin=x
      zmax=1d0
      lzmin=dlog(zmin)
      lzmax=dlog(zmax)
      lhz=(lzmax-lzmin)/dble(itot)

      sum=0d0
      
      do i=1,itot
         lz=lzmin+lhz*dble(i)
         z=dexp(lz)

         call evolvePDFphoton(z,q0,garr,phot)

         wt=(x/z)**2+(1d0-x/z)**2
         wt=wt*3d0 
         wt=wt*phot*x/z
         wt=wt*lhz

         sum=sum+wt
         
      enddo

      out=sum

      return
      end
