      subroutine F1F2el(q2,f1,f2)
      implicit none
      double precision a0e,a1e,a2e,a0m,a1m,a2m
      double precision ge,gm,fe,fm,f1,f2,q2
      double precision geint,gmint

      include 'mp.f'
      
      a0e=0.98462d0
      a1e=0.68414d0
      a2e=0.01933d0
      a0m=0.28231d0
      a1m=1.34919d0
      a2m=0.55473d0
      ge=(a0e/(1d0+q2/a1e)**2+(1d0-a0e)/(1d0+q2/a2e)**2)**2
      gm=(a0m/(1d0+q2/a1m)**2+(1d0-a0m)/(1d0+q2/a2m)**2)**2
      gm=gm*7.78d0

ccccc interpolate

      if(q2.lt.10d0)then
         gm=7.78d0*gmint(q2)**2      
         ge=geint(q2)**2
      else
         gm=0d0
         ge=0d0
      endif

cccccccc

c$$$      ge=1d0/(1d0+q2/0.71d0)**2
c$$$      gm=dsqrt(7.78d0)*ge
      
      fe=(4d0*mp**2*ge+q2*gm)/(4d0*mp**2+q2)
      fm=gm

      f1=fm/2d0
      f2=fe
      
      return
      end

      function geint(t)
      implicit none
      double precision t,geint,m
      integer i,j

      include 'pdfinf.f'
      include 'gcoh.f'

      j=2
      if(ipdf.eq.59)j=4
      if(ipdf.eq.60)j=6
      
      i=nint((t-0.005d0)/0.01d0)

      if(((t-0.005d0)/0.01d0).gt.dble(i))i=i+1

      m=(gcoh(j,i+1)-gcoh(j,i))/0.01d0

      geint=gcoh(j,i)+m*(t-gcoh(1,i))

      if(t.lt.0.005d0)then
         m=(gcoh(j,1)-1d0)/0.005d0
         geint=1d0+m*t
      endif
      
      return
      end

      function gmint(t)
      implicit none
      double precision t,gmint,m
      integer i,j

      include 'pdfinf.f'
      include 'gcoh.f'

      j=3
      if(ipdf.eq.59)j=5
      if(ipdf.eq.60)j=7
      
      i=nint((t-0.005d0)/0.01d0)

      if(((t-0.005d0)/0.01d0).gt.dble(i))i=i+1

      m=(gcoh(j,i+1)-gcoh(j,i))/0.01d0

      gmint=gcoh(j,i)+m*(t-gcoh(1,i))

      if(t.lt.0.005d0)then
         m=(gcoh(j,1)-1d0)/0.005d0
         gmint=1d0+m*t
      endif
      
      return
      end

      subroutine readcoh
c      implicit double precision(a-y)
      implicit none
      double precision diff_E,diff_M,geunc1,geunc2,gmunc1,gmunc2
      double precision dum,gcohu1,gcohu2,gcohu3
      integer i

      include 'gcoh.f'
      
      open(40,file='../src/diss/SplinesWithVariableKnots.dat')
      open(41,file='../src/diss/SplinesWithVariableKnots_Unpol.dat')
      
      do i=1,1000
         read(40,*)gcoh(1,i),gcoh(2,i),dum,geunc1,geunc2,gcoh(3,i),dum
     &        ,gmunc1,gmunc2
         read(41,*)dum,gcohu2,dum,dum,dum,gcohu3

         diff_E=gcohu2-gcoh(2,i)
         diff_M=gcohu3-gcoh(3,i)

         gcoh(4,i)=gcoh(2,i)-dsqrt(diff_E**2+geunc2**2)
         gcoh(5,i)=gcoh(3,i)-dsqrt(diff_M**2+gmunc2**2)
         
         gcoh(6,i)=gcoh(2,i)+dsqrt(diff_E**2+geunc1**2)
         gcoh(7,i)=gcoh(3,i)+dsqrt(diff_M**2+gmunc1**2)
     
      enddo
      
      close(40)
      close(41)
      
      return
      end

