ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                         c 
c     SFGen generator for EW processes in the structure   c
c     function approach                                   c
c                                                         c 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     ***********************************************
c     *   v1.4                       26/06/24       *
c     *                                             *
c     *  Authors: Lucian Harland-Lang               *
c     *  (lucian.harland-lang@physics.ox.ac.uk)     *
c     *                                             *
c     *  For details see :                          *
c     *                                             *
c     *  arXiv 1910.10178                           *
c     *  arXiv 2101.04127                           * 
c     *                                             *
c     *  Available at :                             *
c     *  https://sfgen.hepforge.org                 *                       
c     *                                             *
c     ***********************************************
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      program SFGen
      implicit none
      double precision ran2,randum,t2
      double precision mass,beta
      double precision xsp,xsm,xs0,sd,sdo,sd1,chi2a
      double precision avgi,avgio,avgi1
      integer i,j,k
      integer nhistmax
      integer outl
      integer iinc,ncallu
      logical histol
      character*100 dum
      integer idum
      COMMON /ranno/ idum

      include 'pdfinf.f'
      include 'genunw.f'
      include 'procn.f'
      include 'gencuts.f'
      include 'pi.f'
      include 'pdg.f'
      include 'unweighted.f'
      include 'bin.f'
      include 'ewpars.f'
      include 'zi.f'
      include 'vars.f'
      include 'mom.f'
      include 'range.f'
      include 'polarization.f'
      include 'proc.f'
      include 'mq.f'
      include 'norm.f'
      include 'decay.f'
      include 'record.f'
      include 'mp.f'
      include 'output.f'
      include 'nhist.f'
      include 'vegas.f'
      include 'vegaspars.f'
      include 'leshouches.f'
      include 'eff.f'
      include 'prec.f'
      include 'rech.f'
      include 'ptXcuts.f'
      include 'diff.f'
      include 'diss.f'
      include 'kmu.f'
      include 'wmax.f'
      include 'NSF.f'
      include 'llscat.f'
      include 'zinit.f'
      include 'wtarr.f'
      include 'nhisterr.f'
      
ccccccc

      read(*,*)dum
      read(*,*)dum
      read(*,*)dum
      read(*,*)rts
      read(*,*)dum
      read(*,*)dum
      read(*,*)proc
      read(*,*)outtag
      read(*,*)diff
      read(*,*)SFerror
      read(*,*)NSF
      read(*,*)zinit
      read(*,*)subt
      read(*,*)lep1
      read(*,*)lep2
      read(*,*)kmu
      read(*,*)dum
      read(*,*)dum
      read(*,*)dum
      read(*,*)coll
      read(*,*)PDFname
      read(*,*)PDFmember
      read(*,*)dum
      read(*,*)dum
      read(*,*)dum
      read(*,*)ncall
      read(*,*)itmx
      read(*,*)prec
      read(*,*)ncall1
      read(*,*)inccall
      read(*,*)itend
      read(*,*)iseed
      read(*,*)dum
      read(*,*)dum
      read(*,*)dum
      read(*,*)genunw
      read(*,*)nev
      read(*,*)erec
      read(*,*)dum
      read(*,*)dum
      read(*,*)dum
      read(*,*)ymin
      read(*,*)ymax
      read(*,*)mmin
      read(*,*)mmax
      read(*,*)gencuts
      read(*,*)dum
      read(*,*)dum
      read(*,*)dum
      read(*,*)ptamin
      read(*,*)ptbmin
      read(*,*)etaamin
      read(*,*)etaamax
      read(*,*)etabmin
      read(*,*)etabmax
      read(*,*)ptllmin

      if(proc.eq.4)nsf=.false.

c      SCerror=.true.
      zfinal=.true.
      if(subt)coll=.true.
      
      diffsd=diff
      if(diff.eq.'sda'.or.diff.eq.'sdb')then
         diff='sd'
      else
         diffsd='n'
      endif
      
cccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc

      call length(outtag,outl)

      open(45,file='evrecs/evrec'//outtag(1:outl)//'.dat')

      wmax=0d0
      evnum=0    

      if(erec.eq.'hepmc')then
         erech=.true.
         erec='lhe'
      endif

      gf=1.16639d-5
      v=dsqrt(1d0/dsqrt(2d0)/gf)
      mmu=0.10566d0
      mp=0.938272046d0
      mw=80.318d0
      me=0.511d-3
      mtau=1.77682d0
      mb=4.75d0
      mc=1.4d0
      mt=172.5d0
      alpha=7.2974d-3
      pi=dacos(-1d0)
      conv=389379d3
      zi=(0d0,1d0)

      decay2=.false.
      decay3=.false.
      decay4=.false.
      decay6=.false.

      if(NSF.neqv..true.)interf=.false.
      if(noSF)then
         interf=.false.
         NSF=.true.
      endif

cccccccccccccccccccccccccc
      
      call inpdf
      call supinit      
      call header
      call gaminit
      call gaminit_comb
      call readcoh

cccccccccccccccccccccccc
      
      SFerror_o=.false.
      if(SFerror)then
         SFerror_o=.true.
         SFerror=.false.
      endif
      
cccccccccccccccccccccccccc

      
      call apfelinit
      
      if(coll)then
         ndim=ndim+1
         goto 300
      endif
      
      difftot=.false.
      if(diff.eq.'el')then
         diss1=.false.
         diss2=.false.
      elseif(diff.eq.'sd')then
         diss1=.true.
         diss2=.false.
         ndim=ndim+1
      elseif(diff.eq.'dd')then
         diss1=.true.
         diss2=.true.
         ndim=ndim+2
      elseif(diff.eq.'tot')then
         diss1=.true.
         diss2=.true.
         ndim=ndim+3
         difftot=.true.
      endif
      
ccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      
 300  s=rts**2
      beta=dsqrt(1d0-4d0*mp**2/s)

      q(1,1)=0d0
      q(2,1)=0d0
      q(3,1)=rts/2d0*beta
      q(4,1)=rts/2d0

      q(1,2)=0d0
      q(2,2)=0d0
      q(3,2)=-rts/2d0*beta
      q(4,2)=rts/2d0
      
      pdgid(1)=2212
      pdgid(2)=2212
      pdgid(3)=2212
      pdgid(4)=2212

ccccccccccccccccccccccccccccccccccccccccccccccc
ccccc Les Houches
ccccccccccccccccccccccccccccccccccccccccccccccc

      nprup=1
      idwtup=3
      pdfsup(1)=0
      pdfsup(2)=0
      pdfgup(1)=0
      pdfgup(2)=0
      idprup=0
      xwgtup=1d0
      aqedup=alpha

ccc   NEW LHE init

      pdfsup(1)=247000
      pdfsup(2)=247000
      pdfgup(1)=0
      pdfgup(2)=0 
  
      mothup(1,5)=0
      mothup(2,5)=0
      mothup(1,6)=0
      mothup(2,6)=0

      icolup(1,5)=0
      icolup(2,5)=0
      icolup(1,6)=0
      icolup(2,6)=0
 
      do i=1,20
         vtimup(i)=0
         spinup(i)=9
      enddo

      if(proc.le.3)nup=6
      if(proc.eq.4)nup=8

ccccccccc
      
cccccccccccc
     
      nhist=0
      nhistmax=20

ccccccccccccccc

      histol=.true.

ccccccc    initialise histograms

      if(histol)call inithist(nhistmax)
      
cccccccccccccccc

      neff=0
      neff0=0

      do i=1,30        
         xu(i)=1d0
         xl(i)=0d0
      enddo


      ACC=-1D0
      NPRN=1

      idum=-abs(iseed)
      randum=ran2()
      
      ITMX1=1

      bin=.false.
      unw=.false.
      iinc=1
      
            print*,''
      print*,'**************************************************************
     &**************'
      print*,'                Vegas: initialisation run                '
      print*,'                Note : outputs *bare* cross section only '
      print*,'**************************************************************
     &**************'

      CALL VEGAS(cs,AVGI,SD,CHI2A)

            print*,''
      print*,'**************************************************************
     &**************'
      print*,'                Vegas : main run                '
      print*,'**************************************************************
     &**************'

      if(gencuts)then

      print*,''
      print*,'**************************************************************
     &**************'
      print*,''
      write(6,19)dble(neff)/dble(neff0)*100d0
      print*,''

      iinc=nint(dble(neff0)/dble(neff))

      write(6,20)iinc
      print*,''
      print*,'**************************************************************
     &**************'
      print*,''

 19   FORMAT(' Cut Efficiency = ',G10.4,'%')
 20   FORMAT(' => multiply NCALL by ',i4)

      endif

      ITMX=ITMX1
      NCALL=NCALL1
      avgi1=avgi
      sd1=sd

      ncall=ncall*iinc
      inccall=inccall*iinc

 779  bin=.true.
      SFerror=SFerror_o

      
      ncallu=ncall

      unw=.false.
      ren=1d0

      it=1
      itmx=1

      ren=dble(ncall)

      CALL VEGAS1(cs,AVGI,SD,CHI2A)

      prec=prec*1d-2
     
 777  if(dabs(sd/avgi).gt.prec)then

         it=it+1    
         ncall=ncall+inccall     
         ren=dble(ncall)

         CALL VEGAS2(cs,AVGI,SD,CHI2A)
      

         if(it.gt.itend)goto 778

         goto 777

      endif

 778  unw=.true.
      
  10  FORMAT(' cross section = ',G16.7,' +/-',G16.7,' ( ',F9.4,' )')

cccccccccccccc

 999  if(genunw)then

         avgio=avgi
         sdo=sd
      
      print*,''
      print*,'**************************************************************
     &**************'
      print*,'Generating unweighted events'
      print*,'**************************************************************
     &**************'
      print*,''

c      ncall=nev
      ncall=ncallu
      if(ncall.lt.1000)ncall=1000
 566  ren=dble(ncall)
      itmx=1
   
      CALL VEGAS2(cs,AVGI,SD,CHI2A)   

      if(evnum.lt.nev)then

      print*,''
      print*,'**************************************************************
     &**************'
      write(6,100)evnum,nev
      print*,'**************************************************************
     &**************'
      
      endif

 100  format('  generated events so far = ',i7,'    total = ',i7)

c      ncall=ncall+nev
      ncall=ncall+inccall
     
      if(evnum.lt.nev)goto 566

      xsecup(1)=avgi
      xerrup(1)=sd
      xmaxup(1)=avgi

      call unwprintq
         
      avgi=avgio
      sd=sdo

      endif

      close(55)
      close(45)

cccccccccccccccc

      if(SFerror)then
         call PDFerror(xsarr,xs0,xsp,xsm)
         xsp=xsp*avgi/xs0
         xsm=xsm*avgi/xs0
      endif
         
      if(difftot)diff='tot'
       
      call length(outtag,outl)
      open(56,file='outputs/output'//outtag(1:outl)//'.dat')
      write(56,*)''
      write(56,*)'**********************************************************
     &**************'
      write(56,301)avgi,sd
      write(56,*)'**********************************************************
     &**************'
      if(SFerror)then
         write(56,*)
      write(56,*)'**********************************************************
     &**************'
         if(coll)then
            write(56,601)xsp/xs0*100d0
            write(56,602)xsm/xs0*100d0
         else
            write(56,501)xsp/xs0*100d0
            write(56,502)xsm/xs0*100d0
         endif
      write(56,*)'**********************************************************
     &**************'
      endif
      write(56,*)
      write(56,*)'**********************************************************
     &**************'
            call length(procn,outl)
      write(56,*)'* ',procn(1:outl),' production'
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''
      write(56,*)'********************  Input parameters *******************
     &**************'
      write(56,99)' *',rts,' :  CMS collision energy (GeV)'
      call length(PDFname,outl)
      write(56,96)' *',PDFname(1:outl),' :  PDF set'
      write(56,97)' *',PDFmember,' :  PDF member'
      call length(outtag,outl)
      write(56,96)' *',outtag(1:outl)//'.dat',' :  Output file'
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''
      write(56,*)'********************  Process parameters *********************
     &**************'
      write(56,97)' *',proc,' :  Process number'
      call length(diff,outl)
      write(56,96)' *',diff(1:outl),' :  Dissociation tag '
      write(56,98)' *',NSF,' :  NSF'
      write(56,98)' *',noSF,' :  noSF'
      write(56,98)' *',interf,' :  interf'
      call length(lep1,outl)
      write(56,96)' *',lep1(1:outl),' :  Lepton 1 (process 4) '
      call length(lep2,outl)
      write(56,96)' *',lep2(1:outl),' :  Lepton 2 (process 4) '
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''
      write(56,*)'********************* Integration parameters  ******************
     &**************'
      write(56,97)' *',ncall,' :  Preconditioning calls'
      write(56,97)' *',itmx,' :  Preconditioning iterations'
      write(56,99)' *',prec,' :  Percentage accuracy'
      write(56,97)' *',ncall1,' :  Calls in first main iteration'
      write(56,97)' *',inccall,' :  Increase calls per iteration'
      write(56,97)' *',itend,' :  Maximum number of iterations'
      write(56,97)' *',iseed,' :  Random number seed'
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''
      write(56,*)'********************* Unweighted Events  *****************
     &**************'
      write(56,98)' *',genunw,' :  Generate unweighted events'
      if(genunw)then
         call length(erec,outl)
         write(56,97)' *',nev,' :  Number of events'
         if(erech)then
            write(56,96)' *','hepmc',' : Record format'
         else
            write(56,96)' *',erec(1:outl),' : Record format'
         endif
      endif
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''
      write(56,*)'********************* General Cuts ***********************
     &**************'
      write(56,99)' *',ymin,' :  Minimum object rapidity'
      write(56,99)' *',ymax,' :  Maximum object rapidity'
      write(56,99)' *',mmin,' :  Minimum object mass'
      write(56,99)' *',mmax,' :  Maximum object mass'
      write(56,98)' *',gencuts,' :  Include further cuts'
      write(56,98)' *',gencuts,' :  Include spin correlations'
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''
      write(56,*)'***************** 2-body decay cuts **********************
     &**************'
      write(56,99)' *',ptamin,' :  pT(a) min'
      write(56,99)' *',ptbmin,' :  pT(b) min'
      write(56,99)' *',etaamin,' :  eta(a) min'
      write(56,99)' *',etaamax,' :  eta(a) max'
      write(56,99)' *',etabmin,' :  eta(b) min'
      write(56,99)' *',etabmax,' :  eta(b) max'
      write(56,99)' *',ptllmin,' :  ptll min'
      write(56,*)'**********************************************************
     &**************'
      write(56,*)''

 99   format(a,f24.4,8x,a)
 97   format(a,i24,8x,a)
 96   format(a,a24,8x,a)
 98   format(a,l24,8x,a)

      close(56)

      if(histol)then

         if(SFerror)nhist=nhisterr
         
      do j=1,nhist
           call histo2(j,0)
      enddo

      endif

      print*,''
      write(6,301)avgi,sd
      print*,''

 301  format(' Cross section = ',G16.7,' +/-',G16.7,' pb')

      if(SFerror)then
         if(coll)then
            write(6,601)xsp/xs0*100d0
            write(6,602)xsm/xs0*100d0
         else
            write(6,501)xsp/xs0*100d0
            write(6,502)xsm/xs0*100d0
         endif
      endif

 501  format(' SF uncertainty + : ',G16.7, '%')
 502  format(' SF uncertainty - : ',G16.7, '%')
 601  format(' PDF uncertainty + : ',G16.7, '%')
 602  format(' PDF uncertainty - : ',G16.7, '%')
      print*,''

      call cpu_time(t2)
      print*,'time elapsed = ', t2, ' s'
      
      stop
      end
