ccc   prints out header information
      subroutine header
      implicit double precision(a-y)
      integer outl,outl1
    
      include 'gencuts.f'
      include 'range.f'
      include 'unweighted.f'
      include 'vegas.f'
      include 'vegaspars.f'
      include 'proc.f'
      include 'pdfinf.f'
      include 'genunw.f'
      include 'decay.f'
      include 'procn.f'
      include 'vars.f'
      include 'pdg.f'    
      include 'record.f'
      include 'output.f'
      include 'prec.f'
      include 'rech.f'
      include 'llscat.f'
      include 'diff.f'
      include 'zinit.f'
      include 'NSF.f'
      include 'diss.f'
      include 'ptXcuts.f'
      
      call length(procn,outl)

      print*,'***********************************************'
      print*,'*****************  SFGen v1.04 ****************'
      print*,'***********************************************'
      print*,'*   v1.04                     DATE  26/06/24  *'
      print*,'*                                             *'
      print*,'* Authors: Lucian Harland-Lang                *'
      print*,'* (lucian.harland-lang@physics.ox.ac.uk)      *'
      print*,'*                                             *'
      print*,'* For details see :                           *'
      print*,'*                                             *'
      print*,'* arXiv 1910.10178                            *'
      print*,'* arXiv 2101.04127                            *'
      print*,'*                                             *'
      print*,'*  Available at :                             *'
      print*,'*  https://sfgen.hepforge.org                 *'
      print*,'*                                             *'
      print*,'***********************************************'
      print*,''
      print*,'**********************************************************
     &**************'
      call length(procn,outl)
      print*,'* ',procn(1:outl),' production'
      print*,'**********************************************************
     &**************'
      print*,''
      print*,'********************  Input parameters *******************
     &**************'
      write(*,99)' *',rts,' :  CMS collision energy (GeV)'
      call length(PDFname,outl)
      write(*,96)' *',PDFname(1:outl),' :  PDF set'
      write(*,97)' *',PDFmember,' :  PDF member'
      call length(outtag,outl)
      write(*,96)' *',outtag(1:outl)//'.dat',' :  Output file'
      print*,'**********************************************************
     &**************'
      print*,''
      print*,'********************  Process parameters *********************
     &**************'
      write(*,97)' *',proc,' :  Process number'
      call length(diff,outl)
      write(*,96)' *',diff(1:outl),' :  Dissociation tag '
      write(*,98)' *',NSF,' :  NSF'
      write(*,98)' *',noSF,' :  noSF'
      write(*,98)' *',interf,' :  interf'
      write(*,98)' *',Zinit,' :  Zinit'
      write(*,98)' *',Zfinal,' :  Zfinal'
      write(*,98)' *',coll,' :  coll'
      write(*,98)' *',subt,' :  subt'
      call length(lep1,outl)
      write(*,96)' *',lep1(1:outl),' :  Lepton 1 (process 4) '
      call length(lep2,outl)
      write(*,96)' *',lep2(1:outl),' :  Lepton 2 (process 4) '
      print*,'**********************************************************
     &**************'
      print*,''
      print*,'********************* Integration parameters  ******************
     &**************'
      write(*,97)' *',ncall,' :  Preconditioning calls'
      write(*,97)' *',itmx,' :  Preconditioning iterations'
      write(*,99)' *',prec,' :  Percentage accuracy'
      write(*,97)' *',ncall1,' :  Calls in first main iteration'
      write(*,97)' *',inccall,' :  Increase calls per iteration'
      write(*,97)' *',itend,' :  Maximum number of iterations'
      write(*,97)' *',iseed,' :  Random number seed'
      print*,'**********************************************************
     &**************'
      print*,''
      print*,'********************* Unweighted Events  *****************
     &**************'
      write(*,98)' *',genunw,' :  Generate unweighted events'
      if(genunw)then
         call length(erec,outl)
         write(*,97)' *',nev,' :  Number of events'
         if(erech)then
            write(*,96)' *','hepmc',' : Record format'
         else
            write(*,96)' *',erec(1:outl),' : Record format'
         endif
      endif
      print*,'**********************************************************
     &**************'
      print*,''
      print*,'********************* General Cuts ***********************
     &**************'
      write(*,99)' *',ymin,' :  Minimum object rapidity'
      write(*,99)' *',ymax,' :  Maximum object rapidity'
      write(*,99)' *',mmin,' :  Minimum object mass'
      write(*,99)' *',mmax,' :  Maximum object mass'
      write(*,98)' *',gencuts,' :  Include further cuts'
      write(*,98)' *',gencuts,' :  Include spin correlations'
      print*,'**********************************************************
     &**************'
      print*,''
      print*,'***************** 2-body decay cuts **********************
     &**************'
      write(*,99)' *',ptamin,' :  pT(a) min'
      write(*,99)' *',ptbmin,' :  pT(b) min'
      write(*,99)' *',etaamin,' :  eta(a) min'
      write(*,99)' *',etaamax,' :  eta(a) max'
      write(*,99)' *',etabmin,' :  eta(b) min'
      write(*,99)' *',etabmax,' :  eta(b) max'
      write(*,99)' *',ptllmin,' :  ptll min'
      print*,'**********************************************************
     &**************'
      print*,''

 99   format(a,f24.4,8x,a)
 97   format(a,i24,8x,a)
 96   format(a,a24,8x,a)
 98   format(a,l24,8x,a)

      return
      end
