ccc   initialises process dependent parameters- process numbers listed below

ccc   proc=1 - gamma gamma --> e+e- production
ccc   proc=2 - gamma gamma --> mu+mu- production
ccc   proc=3- gamma gamma --> tau+tau- production
ccc   proc=4- gamma gamma --> lepton lepton
      
cccccccccccccccc
cccccccccccccccc

      subroutine supinit
      implicit none
      integer i1,id1,id2,i,j

      include 'mq.f'
      include 'procn.f'
      include 'polarization.f'
      include 'proc.f'
      include 'pdg.f'
      include 'decay.f'
      include 'leshouches.f'
      include 'ewpars.f'
      include 'vegas.f'
      include 'pi.f'
      include 'diff.f'
      include 'diss.f'
      include 'mres.f'
      include 'llscat.f'
      include 'ewsf.f'
      
      if(proc.eq.1)then
        pol=4
         if(coll)then
            ndim=2
         else
            ndim=6
         endif
         mq=me

         llsign(1)=-1d0
         llsign(2)=1d0
         llsign(3)=-1d0
         llsign(4)=1d0
        
         dps=2
         procn='gamma gamma --> e+ e-'
         
         pdgid(11)=11
         pdgid(12)=-11
         istup(11)=1  
         istup(12)=1
         mothup(1,11)=1
         mothup(2,11)=2
         mothup(1,12)=1
         mothup(2,12)=2 
         icolup(1,11)=0
         icolup(2,11)=0
         icolup(1,12)=0
         icolup(2,12)=0   
      elseif(proc.eq.2)then
         pol=4
         if(coll)then
            ndim=2
         else
            ndim=6
         endif
         mq=mmu
         
         llsign(1)=-1d0
         llsign(2)=1d0
         llsign(3)=-1d0
         llsign(4)=1d0
        
         dps=2
         procn='gamma gamma --> mu+ mu-'
         
         pdgid(11)=13
         pdgid(12)=-13 
         istup(11)=1  
         istup(12)=1
         mothup(1,11)=1
         mothup(2,11)=2
         mothup(1,12)=1
         mothup(2,12)=2 
         icolup(1,11)=0
         icolup(2,11)=0
         icolup(1,12)=0
         icolup(2,12)=0   
      elseif(proc.eq.3)then
         pol=4
         if(coll)then
            ndim=2
         else
            ndim=6
         endif
         mq=mtau

         llsign(1)=-1d0
         llsign(2)=1d0
         llsign(3)=-1d0
         llsign(4)=1d0
        
         dps=2
         procn='gamma gamma --> tau+ tau-'
         
         pdgid(11)=15
         pdgid(12)=-15 
         istup(11)=1  
         istup(12)=1
         mothup(1,11)=1
         mothup(2,11)=2
         mothup(1,12)=1
         mothup(2,12)=2 
         icolup(1,11)=0
         icolup(2,11)=0
         icolup(1,12)=0
         icolup(2,12)=0   
      elseif(proc.eq.4)then
   
         pol=8

         ndim=13

         if(lep1.eq.'e+'.or.lep1.eq.'e-')then
            mq1=me
         elseif(lep1.eq.'mu+'.or.lep1.eq.'mu-')then
            mq1=mmu
         elseif(lep1.eq.'tau+'.or.lep1.eq.'tau-')then
            mq1=mtau
         endif

         if(lep1.eq.'e+')id1=-11
         if(lep1.eq.'mu+')id1=-13
         if(lep1.eq.'tau+')id1=-15
         if(lep1.eq.'e-')id1=11
         if(lep1.eq.'mu-')id1=13
         if(lep1.eq.'tau-')id1=15

 
         if(lep2.eq.'e+'.or.lep2.eq.'e-')then
            mq2=me
         elseif(lep2.eq.'mu+'.or.lep2.eq.'mu-')then
            mq2=mmu
         elseif(lep2.eq.'tau+'.or.lep2.eq.'tau-')then
            mq2=mtau
         endif

         if(lep2.eq.'e+')id2=-11
         if(lep2.eq.'mu+')id2=-13
         if(lep2.eq.'tau+')id2=-15
         if(lep2.eq.'e-')id2=11
         if(lep2.eq.'mu-')id2=13
         if(lep2.eq.'tau-')id2=15

         dps=2
         procn='lepton-lepton scattering'

      
         pdgid(11)=id1
         pdgid(12)=id2
         pdgid(13)=-id1
         pdgid(14)=-id2

         do i=1,2
            do j=11,14
               istup(j)=1 
               mothup(i,j)=i
               icolup(i,j)=0d0
            enddo
         enddo
         
         mothup(1,11)=1
         mothup(2,11)=2
         mothup(1,12)=1
         mothup(2,12)=2 
         icolup(1,11)=0
         icolup(2,11)=0
         icolup(1,12)=0
         icolup(2,12)=0
         
      endif
      
      return
      end
