ccc   generates two-body phase space for particles of equal mass mq
      subroutine twojetps(io,mx,mq,rtheta,ps)
      implicit none
      double precision rphi,ran2
      double precision phi,stheta,ctheta
      double precision beta,ps,mx,mq,rtheta
      double precision px(4),pcm(4)
      double precision pboo(4)
      integer i,io

      include 'partonmom2.f'
      include 'pi.f'
      include 'mom.f'

      rphi=ran2()

      phi=2d0*pi*rphi
      ctheta=-1d0+2d0*rtheta
      stheta=dsqrt(1d0-ctheta**2)
      beta=dsqrt(1d0-4d0*mq**2/mx**2)

      pcm(4)=mx/2d0
      pcm(1)=stheta*dcos(phi)*pcm(4)*beta
      pcm(2)=stheta*dsin(phi)*pcm(4)*beta
      pcm(3)=ctheta*pcm(4)*beta

      do i=1,4
         px(i)=q(i,io)
         p1(i)=pcm(i)
      enddo

      p2(4)=pcm(4)
      do i=1,3
         p2(i)=-pcm(i)
      enddo

      call boost(mx,px,pcm,pboo)

      do i=1,4
         q(i,io+1)=pboo(i)
         q(i,io+2)=q(i,io)-q(i,io+1)
      enddo

      ps=4d0*pi*beta
      ps=ps/1d0/32d0/pi**2 ! Phase space factors
      ps=ps/(2d0*pi)**4  ! Reintroduce delta^4() factor
      
      return
      end
