      subroutine phase4(rarr0,wt)
      implicit none
      double precision theta,cthetav,phi,phiv
      double precision theta1,phi1
      double precision wt1,wt2
      double precision s3min,ein
      double precision p1(4),p2(4),p3(4),p4(4),p5(4),p6(4)
      double precision p12(4),p34(4)
      double precision wt,wt0
      double precision pcm(4),pboo(4),px(4),pcmr(4)
      double precision q1arr(4),q2arr(4)
      double precision mat1(3,3)
      double precision q1rf(4),q2rf(4)
      double precision rarr0(30)
      common/qrf/q1rf,q2rf
      
      integer j,i,ir,iw

      include 'pi.f'
      include 'mom.f'
      include 'mq.f'
      include 'diff.f'
      
      if(difftot)then
         ir=10
      elseif(diff.eq.'el')then
         ir=7
      elseif(diff.eq.'sd')then
         ir=8
      elseif(diff.eq.'dd')then
         ir=9
      endif     

      wt0=1d0/(2d0*pi)**4  ! Reintroduce delta^4() factor
      wt0=wt0/(2d0*pi)     ! dm/(2*pi)
      
      do j=1,3
      p12(j)=0d0
      enddo

      ein=dsqrt(q(4,5)**2-q(3,5)**2-q(2,5)**2-q(1,5)**2)
      
ccccccccc q1,q2 in q1-q2 rest frame

      do i=1,4
         q1arr(i)=q(i,1)-q(i,3)
         q2arr(i)=q(i,2)-q(i,4)
      enddo

      
      do i=1,4
         px(i)=-q(i,5)
         pcm(i)=q1arr(i)
      enddo
      px(4)=q(4,5)

      call boost(ein,px,pcm,pboo)

      do i=1,4
         q1rf(i)=pboo(i)
      enddo

      phi1=phiv(pboo)
      theta1=dacos(cthetav(pboo))
      call rmat_init(phi1,theta1,mat1)

      do i=1,4
         px(i)=-q(i,5)
         pcm(i)=q2arr(i)
      enddo
      px(4)=q(4,5)

      call boost(ein,px,pcm,pboo)

      do i=1,4
         q2rf(i)=pboo(i)
      enddo
      
ccccccc  Generate phase space
      
      p12(4)=ein

      s3min=(mq1+mq2)**2
ccccc  p5 + p34 + p6      
      call ps3(ein,rarr0(6),rarr0(ir),rarr0(ir+1),rarr0(ir+2)
     &     ,rarr0(ir+3),rarr0(ir+4),mq1,mq2,s3min,p5,p6,p34,wt1,iw)
      if(iw.eq.1)then ! p34 -> p3 + p4
         call phi3m(rarr0(ir+5),rarr0(ir+6),p34,p3,p4,mq1,mq2,wt2)
      else
         wt=-1d0
         return
      endif      
      
      wt=wt1*wt2*wt0
      
cccccccccccc Now rotate wrt q1,q2 in rest frame

      do i=1,4
         px(i)=q(i,5)
         pcm(i)=p3(i)
      enddo

      call rmat_rot(mat1,pcm,pcmr)   
      
      call boost(ein,px,pcmr,pboo)

      do i=1,4
         q(i,6)=pboo(i)
      enddo
      
      do i=1,4
         pcm(i)=p4(i)
      enddo

      call rmat_rot(mat1,pcm,pcmr)
      
      call boost(ein,px,pcmr,pboo)

      do i=1,4
         q(i,7)=pboo(i)
      enddo

      do i=1,4
         pcm(i)=p5(i)
      enddo

      call rmat_rot(mat1,pcm,pcmr)
      
      call boost(ein,px,pcmr,pboo)

      do i=1,4
         q(i,8)=pboo(i)
      enddo

      do i=1,4
         pcm(i)=p6(i)
      enddo

      call rmat_rot(mat1,pcm,pcmr)
      
      call boost(ein,px,pcmr,pboo)

      do i=1,4
         q(i,9)=pboo(i)
      enddo
      
      return 
      end


ccc   p1 + p2 -> p5 + p34 + p6 body phase space, with m34 integrated over
ccc   Includes all factors of pi      
      subroutine ps3(mcap,r1,r2,r3,r4,r5,r6,m1,m2,s3min,p1,p2,p3,wt,iw)
      implicit none
      double precision rj,ran2,wtj,wtang1,wtang2
      double precision y,ymax,ymin
      double precision sint1,sint2,signp,signm,phi1,phi2
      double precision s3,s3max,qsq,pmod1,pmod2,pmod3,s3min
      double precision m3,fe1,ep,em,egam,e3,e2min,e2max,e2,e2t,e1t,e1
      double precision del,cost1,cost2,cost12,c,beta,beta0,b,a,ab
      double precision wt
      double precision alpha0,alpha,m1,m2
      double precision r1,r2,r3,r4,r5,r6,mcap
      integer i,j,k,n,iw
      double precision p1(4),p2(4),p3(4)
      double precision q1rf(4),q2rf(4)
      common/qrf/q1rf,q2rf
      common/costs/cost1,cost2
      
      include 'pi.f'
      
      iw=0
      
      s3max=(mcap-m1-m2)**2

      s3=s3min+(s3max-s3min)*r6
      m3=dsqrt(s3)

      e2max=mcap/2d0
      e2max=e2max+(m2**2-(m1+m3)**2)/2d0/mcap
      e2min=m2

cccccccc

      e2=e2min+(e2max-e2min)*r5      
      phi2=2d0*pi*r3
      
cccccccc

      e2t=e2

      egam=q2rf(4)
      qsq=-(q2rf(4)**2-q2rf(3)**2-q2rf(2)**2-q2rf(1)**2)
      alpha0=qsq+2d0*egam*e2t
      beta0=2d0*egam*e2t*dsqrt(1d0-m2**2/e2t**2)
     &     *dsqrt(1d0+qsq/egam**2)
      
      alpha=alpha0
      beta=-beta0
      
      ymin=-1d0/beta*dlog(alpha+beta)
      ymax=-1d0/beta*dlog(alpha-beta)
      
      y=ymin+(ymax-ymin)*r4
      
      cost2=(alpha-dexp(-beta*y))/beta
      wtang2=(ymax-ymin)*(alpha-beta*cost2)      
      wtang2=wtang2*2d0*pi
      
cccccccc
      
      sint2=dsqrt(1d0-cost2**2)

cccccccccccccc

      phi1=2d0*pi*r1

      e1t=(e2max-e2)/2d0
      
      egam=q1rf(4)
      qsq=-(q1rf(4)**2-q1rf(3)**2-q1rf(2)**2-q1rf(1)**2)
      alpha0=qsq+2d0*egam*e1t
      beta0=2d0*egam*e1t*dsqrt(1d0-m1**2/e1t**2)
     &     *dsqrt(1d0+qsq/egam**2)

      alpha=alpha0
      beta=beta0
      
      ymin=-1d0/beta*dlog(alpha+beta)
      ymax=-1d0/beta*dlog(alpha-beta)
      y=ymin+(ymax-ymin)*r2

      cost1=(alpha-dexp(-beta*y))/beta
      wtang1=(ymax-ymin)*(alpha-beta*cost1)
      wtang1=wtang1*2d0*pi

      sint1=dsqrt(1d0-cost1**2)         
      
cccccc      
         
      cost12=sint1*sint2*(dsin(phi1)*dsin(phi2)
     &     +dcos(phi1)*dcos(phi2))+cost1*cost2
      
      pmod2=dsqrt(e2**2-m2**2)
      p2(4)=e2
      p2(3)=pmod2*cost2
      p2(2)=pmod2*sint2*dsin(phi2)
      p2(1)=pmod2*sint2*dcos(phi2)
      
      alpha=mcap-e2
      beta=alpha**2-pmod2**2+m1**2-m3**2

      a=4d0*(alpha**2-pmod2**2*cost12**2)
      b=-4d0*alpha*beta
      c=beta**2+4d0*m1**2*pmod2**2*cost12**2
      
      del=b**2-4d0*a*c
      
      if(del.lt.0d0)then
         wt=0d0
         return
      endif
      
      ep=(-b+dsqrt(del))/2d0/a
      em=(-b-dsqrt(del))/2d0/a
      
ccccccccccccccc

      signm=(beta-2d0*alpha*em)/cost12/dabs((beta-2d0*alpha*em)/cost12)
      signp=(beta-2d0*alpha*ep)/cost12/dabs((beta-2d0*alpha*ep)/cost12)

      if(signm.gt.0d0)then
         e1=em
         wtj=1d0
      elseif(signp.gt.0d0)then
         e1=ep
         wtj=1d0
      else
         wt=0d0
         return
      endif

      if(signm.gt.0d0.and.signp.gt.0d0)then
         wtj=2d0
         rj=ran2()
         if(rj.gt.0.5d0)then
            e1=ep
         else
            e1=em
         endif
      endif
   
      if(e1.lt.0d0)then
         wt=0d0
         return
      endif

ccccccccccccc

      egam=q1rf(4)
      qsq=-(q1rf(4)**2-q1rf(3)**2-q1rf(2)**2-q1rf(1)**2)
      alpha0=qsq+2d0*egam*e1
      beta0=2d0*egam*e1*dsqrt(1d0-m1**2/e1**2)
     &     *dsqrt(1d0+qsq/egam**2)     
      ab=beta0/alpha0

cccccccc

      egam=q2rf(4)
      qsq=-(q2rf(4)**2-q2rf(3)**2-q2rf(2)**2-q2rf(1)**2)
      alpha0=qsq+2d0*egam*e2
      beta0=2d0*egam*e2*dsqrt(1d0-m2**2/e2**2)
     &     *dsqrt(1d0+qsq/egam**2)
      
cccccccccccc      
      
      pmod1=dsqrt(e1**2-m1**2)
      
      p1(4)=e1
      p1(3)=pmod1*cost1
      p1(2)=pmod1*sint1*dsin(phi1)
      p1(1)=pmod1*sint1*dcos(phi1)
      
      e3=mcap-e1-e2
      
      if(e3.lt.0d0)then
         wt=0d0
         return
      endif
      
      pmod3=dsqrt(e3**2-m3**2)
      p3(4)=e3
      do i=1,3
         p3(i)=-p1(i)-p2(i)
      enddo

      if(e1.lt.m1)then
         wt=0d0
         return
      endif

      if(e2.lt.m2)then
         wt=0d0
         return
      endif

      if(e3.lt.m3)then
         wt=0d0
         return
      endif
      
cccccccccccccc
      
      fe1=1d0+e1/e3*(1d0+pmod2*cost12/pmod1)
      
      wt=pmod1*pmod2/e3/dabs(fe1)
      wt=wt/8d0/(2d0*pi)**5
      wt=wt*(e2max-e2min)
      wt=wt*(s3max-s3min)
      wt=wt*wtj
      wt=wt*wtang1*wtang2
      
      iw=1
      
      return
      end

      subroutine phi3m(xth,xphi,p0,p1,p2,m1,m2,wt)
c     massive particle p0 in rest frame 
c     decaying into p1 fixed mass m1 and p2 fixed mass m2.
c     vectors returned p1 and p2 are in the frame in which 
C     p0 is supplied
c result is 1/8/pi * 2|p|/sqrts  * domega/(4*pi)
c     factor of (2*pi)^4 included in definition of phase space

      implicit none      
      double precision p0(4),p1(4),p2(4),p1cm(4)
      double precision xth,xphi,phi,s,roots,costh,sinth
      double precision wt0,wt
      double precision m1,m2,m1sq,m2sq,lambda,lambda2,smin
      integer j

      include 'pi.f'
      
      wt=0d0

      wt0=1d0/8d0/pi

      s=p0(4)**2-p0(1)**2-p0(2)**2-p0(3)**2  

      smin=(m1+m2)**2

      roots=dsqrt(s)
      m1sq=m1**2
      m2sq=m2**2
      costh=2d0*xth-1d0    
      sinth=dsqrt(1d0-costh**2)
      phi=2d0*pi*xphi

      lambda2=((s+m1sq-m2sq)**2-4d0*m1sq*s)

      lambda=dsqrt(lambda2)

      p1cm(4)=roots/2d0*(s+m1sq-m2sq)/s
      p1cm(1)=roots/2d0*lambda/s*sinth*dsin(phi)
      p1cm(2)=roots/2d0*lambda/s*sinth*dcos(phi)
      p1cm(3)=roots/2d0*lambda/s*costh


      call boost(roots,p0,p1cm,p1)
      do j=1,4
      p2(j)=p0(j)-p1(j)
      enddo

      wt=wt0*lambda/s

      return
      end
