      subroutine ll_subt(p)
c      implicit double precision(a-y)
c      implicit complex*16(z)
      implicit none 
      double precision alphaEM,sign,pzp
      complex*16 zt,zout
      double precision q1(4),q2(4)
      complex*16 uelb(4),vpos(4),vsq(4),vsqb(4),usq(4),usqb(4)
      integer i,j,k,h1,h2,i1,i2,p
      complex*16 zqq(4),zsing_subt(10,4)

      include 'mom.f'
      include 'gmatrices.f'
      include 'gmatrices_comb.f'
      include 'ewpars.f'
      include 'pi.f'
      include 'vars.f'
      include 'partonmom2.f'
      include 'norm.f'
      include 'mq.f'
      include 'zi.f'
      include 'zoutarr.f'
      include 'diss.f'
      include 'x.f'
      include 'ewsf.f'

      pzp=1d0/(4d0*Sin2ThetaW*(1d0-Sin2ThetaW))
            
      do i=1,2
         q1(i)=0d0
         q2(i)=0d0
      enddo
      
      q1(4)=x1*rts/2d0
      q1(3)=q1(4)
      q2(4)=x2*rts/2d0
      q2(3)=-q2(4)

      do i=1,4        
         q(i,16)=q1(i)
         q(i,17)=q2(i)
      enddo

      if(p.eq.1)then            ! ++
         call upb(6,uelb)
         call vp(7,vpos)
      elseif(p.eq.2)then        ! --
         call umb(6,uelb)
         call vm(7,vpos)
      elseif(p.eq.3)then        ! +-
         call umb(6,uelb)
         call vp(7,vpos)
      elseif(p.eq.4)then        ! -+
         call upb(6,uelb)
         call vm(7,vpos)
      endif

      do j=1,4
         zout=0d0
         do i1=1,4
            do i2=1,4
               zout=zout+uelb(i1)*gmatrix(j,i1,i2)*vpos(i2)
            enddo
         enddo
         zsing_subt(p,j)=zout*4d0*pi*alphaEM(mx**2)*dsqrt(conv)
      enddo

      do h1=1,2
         do h2=1,2

            if(h1.eq.1.and.h2.eq.1)then ! g5 u = +
               call up(16,usq)
               call vpb(17,vsqb)
               sign=1d0
            elseif(h1.eq.1.and.h2.eq.2)then ! g5 u = +
               call up(16,usq)
               call vmb(17,vsqb)
               sign=1d0
            elseif(h1.eq.2.and.h2.eq.1)then ! g5 u = -
               call um(16,usq)
               call vpb(17,vsqb)
               sign=-1d0
            else  ! g5 u = -
               call um(16,usq)
               call vmb(17,vsqb)
               sign=-1d0
            endif

            do i=1,4
               zout=0d0
               do i1=1,4
                  do i2=1,4
                     zout=zout+vsqb(i1)*gmatrix(i,i1,i2)*usq(i2)
                  enddo
               enddo
               zqq(i)=zout
            enddo

            zout=0d0
            do i=1,4
               zt=zqq(i)*zsing_subt(p,i)
               if(i.lt.4)zt=-zt
               zout=zout+zt
            enddo
            
            zsubt(p,1,h1,h2)=zout*eq(2)/mx**2 ! up type quark, gamma
            zsubt(p,2,h1,h2)=zout*eq(1)/mx**2 ! down type quark, gamma
            zsubt(p,5,h1,h2)=zout*(vq(2)-aq(2)*sign)*(ve-ae*llsign(p))
     &           /(mx**2-mz**2+zi*mz*gamz)*pzp ! up type quark, Z
            zsubt(p,6,h1,h2)=zout*(vq(1)-aq(1)*sign)*(ve-ae*llsign(p))
     &           /(mx**2-mz**2+zi*mz*gamz)*pzp ! down type quark, Z
  
         enddo
      enddo

      do h1=1,2
         do h2=1,2

            if(h1.eq.1.and.h2.eq.1)then ! g5 u = +
               call up(17,usq)
               call vpb(16,vsqb)
               sign=1d0
            elseif(h1.eq.1.and.h2.eq.2)then ! g5 u = +
               call up(17,usq)
               call vmb(16,vsqb)
               sign=1d0
            elseif(h1.eq.2.and.h2.eq.1)then ! g5 u = -
               call um(17,usq)
               call vpb(16,vsqb)
               sign=-1d0
            else  ! g5 u = -
               call um(17,usq)
               call vmb(16,vsqb)
               sign=-1d0
            endif

            do i=1,4
               zout=0d0
               do i1=1,4
                  do i2=1,4
                     zout=zout+vsqb(i1)*gmatrix(i,i1,i2)*usq(i2)
                  enddo
               enddo
               zqq(i)=zout
            enddo

            zout=0d0
            do i=1,4
               zt=zqq(i)*zsing_subt(p,i)
               if(i.lt.4)zt=-zt
               zout=zout+zt
            enddo
            
            zsubt(p,3,h1,h2)=zout*eq(2)/mx**2 ! up type quark, gamma
            zsubt(p,4,h1,h2)=zout*eq(1)/mx**2 ! down type quark, gamma
            zsubt(p,7,h1,h2)=zout*(vq(2)-aq(2)*sign)*(ve-ae*llsign(p))
     &           /(mx**2-mz**2+zi*mz*gamz)*pzp ! up type quark, Z
            zsubt(p,8,h1,h2)=zout*(vq(1)-aq(1)*sign)*(ve-ae*llsign(p))
     &           /(mx**2-mz**2+zi*mz*gamz)*pzp ! down type quark, Z

         enddo
      enddo
             
      return
      end
