ccc   prints out header information
      subroutine headerlhe
      implicit double precision(a-y)
      integer outl
    
      include 'gencuts.f'
      include 'range.f'
      include 'unweighted.f'
      include 'vegas.f'
      include 'vegaspars.f'
      include 'proc.f'
      include 'pdfinf.f'
      include 'genunw.f'
      include 'decay.f'
      include 'procn.f'
      include 'vars.f'
      include 'pdg.f' 
      include 'record.f'
      include 'output.f'
      include 'prec.f'
      
      call length(procn,outl)

      write(45,*)'***********************************************'
      write(45,*)'****************  SFGev v1.04 *****************'
      write(45,*)'***********************************************'
      write(45,*)'*  v1.04              DATE    26/06/24        *'
      write(45,*)'*                                             *'
      write(45,*)'*  Authors: Lucian Harland-Lang               *'
      write(45,*)'*  (lucian.harland-lang@physics.ox.ac.uk      *'
      write(45,*)'*                                             *'
      write(45,*)'*  For details see :                          *'
      write(45,*)'*                                             *'
      write(45,*)'*  arXiv 1910.10178                           *'
      write(45,*)'*  arXiv 2101.04127                           *'  
      write(45,*)'*                                             *'
      write(45,*)'*  Available at :                             *'
      write(45,*)'*  https://sfgen.hepforge.org                 *'
      write(45,*)'*                                             *'
      write(45,*)'***********************************************'
      write(45,*)''
      write(45,*)'******************************************************
     &******************'
      call length(procn,outl)
      write(45,*)'* ',procn(1:outl),' production'
      write(45,*)'******************************************************
     &******************'
      write(45,*)''
      write(45,*)'********************  Input parameters ***************
     &******************'
      write(45,99)' *',rts,' :  CMS collision energy (GeV)'
      write(45,97)' *',proc,' :  Process number'
      call length(outtag,outl)
      write(45,96)' *',outtag(1:outl)//'.dat',' :  Output file'
      write(45,*)'******************************************************
     &******************'
      write(45,*)''
      write(45,*)'********************* Integration parameters  ********
     &******************'
      write(45,97)' *',ncall,' :  Preconditioning calls'
      write(45,97)' *',itmx,' :  Preconditioning iterations'
      write(45,99)' *',prec,' :  Percentage accuracy'
      write(45,97)' *',ncall1,' :  Calls in first main iteration'
      write(45,97)' *',inccall,' :  Increase calls per iteration'
      write(45,97)' *',itend,' :  Maximum number of iterations'
      write(45,97)' *',iseed,' :  Random number seed'
      write(45,*)'********************* Unweighted Events  *************
     &******************'
      write(45,98)' *',genunw,' :  Generate unweighted events'
      if(genunw)then
         call length(erec,outl)
         write(45,97)' *',nev,' :  Number of events'
         write(45,96)' *',erec(1:outl),' : Record format'
      endif
      write(45,*)'******************************************************
     &******************'
      write(45,*)''
      write(45,*)'********************* General Cuts *******************
     &******************'
      write(45,99)' *',ymin,' :  Minimum object rapidity'
      write(45,99)' *',ymax,' :  Maximum object rapidity'
      write(45,99)' *',mmin,' :  Minimum object mass'
      write(45,99)' *',mmax,' :  Maximum object mass'
      write(45,98)' *',gencuts,' :  Include further cuts'
      write(45,*)'*****************************************************
     &******************'
      write(45,*)''
      write(45,*)'***************** 2-body decay cuts ******************
     &*****************'
      write(45,99)' *',ptamin,' :  pT(a) min'
      write(45,99)' *',ptbmin,' :  pT(b) min'
      write(45,99)' *',etaamin,' :  eta(a) min'
      write(45,99)' *',etaamax,' :  eta(a) max'
      write(45,99)' *',etabmin,' :  eta(b) min'
      write(45,99)' *',etabmax,' :  eta(b) max'
      write(45,*)'******************************************************
     &*****************'
      write(45,*)''
  

 99   format(a,f24.4,8x,a)
 97   format(a,i24,8x,a)
 96   format(a,a24,8x,a)
 98   format(a,l24,8x,a)

      return
      end
