ccc   randomizes order of VEGAS unweighted events and
ccc   prints nev events to record
      subroutine unwprintq
      implicit none
      double precision r,range,ran2
      double precision alphas,md2diff,md1diff,md1,md2
      integer i,j,k,l,m,n
      integer evfill(2000000)
      character*10 differec
      
      include 'pdg.f'
      include 'unweighted.f'
      include 'mom.f'
      include 'proc.f'
      include 'decay.f'
      include 'record.f'
      include 'leshouches.f'
      include 'ewpars.f'
      include 'mp.f'
      include 'vars.f'
      include 'x.f'
      include 'vertex.f'
      include 'pvert.f'
      include 'rech.f'
      
      do i=1,evnum
         evfill(i)=1
      enddo

      range=dble(evnum)

      do i=1,nev

 555     r=ran2()

         j=nint(r*range)
         if(dble(j).lt.r*range)j=j+1
         if(evfill(j).eq.0)goto 555
         evfill(j)=0
      
ccccccccccccccccccccccccccccccccccccccccccccccc
ccccc Les Houches
ccccccccccccccccccccccccccccccccccccccccccccccc

         do k=1,nup+6
            idup(k)=pdgid(k)
         enddo
         
         do k=1,nup+6
            do l=1,4
               pup(l,k)=evrec(j,k,l)
            enddo
            pup(5,k)=dsqrt(dabs(pup(4,k)**2-pup(3,k)**2
     &           -pup(2,k)**2-pup(1,k)**2))
            if(idup(k).eq.22)pup(5,k)=0d0
         enddo

         md1=dsqrt(evrec(j,3,4)**2-evrec(j,3,3)**2-evrec(j,3,2)**2
     &        -evrec(j,3,1)**2)
         md2=dsqrt(evrec(j,4,4)**2-evrec(j,4,3)**2-evrec(j,4,2)**2
     &        -evrec(j,4,1)**2)
         
         md1diff=dabs((md1-mp)/mp)
         md2diff=dabs((md2-mp)/mp)

         

         if(md1diff.lt.1d-5.and.md2diff.lt.1d-5)then
            differec='el'
         elseif(md1diff.lt.1d-5)then
            differec='sd2'
         elseif(md2diff.lt.1d-5)then
            differec='sd1'
         else
            differec='dd'
         endif

c         print*,differec
         
         if(i.eq.1)then
            write(45,*)'<LesHouchesEvents version="1.0">'
            write(45,*)'<header>'
            call headerlhe
            write(45,*)'</header>'
            write(45,*)'<init>'
            write(45,302)idup(1),idup(2),pup(4,1),pup(4,2)
     &           ,pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2)
     &           ,idwtup,nprup
            write(45,312)xsecup(1),xerrup(1),xmaxup(1),1
            write(45,*)'</init>'
         endif
         
 302     format(5x,i4,2x,i4,2x,E16.9,2x,E16.9,2x,i5,2x,i5,2x,i6,2x,i6
     &           ,2x,i1,2x,i1)
         
 312     format(E16.9,2x,E16.9,2x,E16.9,2x,i1)
         
         scalup=mx
         aqcdup=alphas(mx**2)

         write(45,*)'<event>'
            if(differec.eq.'el')then
               write(45,304)4,idprup,xwgtup,scalup,aqedup,aqcdup
            do m=5,6
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
            do m=11,nup+6
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo   
         elseif(differec.eq.'dd')then
            write(45,304)6,idprup,xwgtup,scalup,aqedup,aqcdup
            do m=7,nup+6
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
         elseif(differec.eq.'sd1')then
            write(45,304)5,idprup,xwgtup,scalup,aqedup,aqcdup
            do m=7,7
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
            do m=6,6
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
            do m=9,9
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
            do m=11,nup+6
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
         elseif(differec.eq.'sd2')then
            write(45,304)5,idprup,xwgtup,scalup,aqedup,aqcdup
            do m=5,5
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
            do m=8,10,2
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
            do m=11,nup+6
               write(45,303)idup(m),istup(m),mothup(1,m),
     &              mothup(2,m),icolup(1,m),icolup(2,m),pup(1,m)
     &              ,pup(2,m),pup(3,m),pup(4,m),pup(5,m),vtimup(m)
     &              ,spinup(m)
            enddo
         endif
         write(45,*)'</event>'

 304        format(i2,4x,i1,3x,F2.0,3x,E16.9,3x,E16.9,3x,E16.9)
            
               
 500     enddo

      if(erec.eq.'lhe')then
         if(erech)then
         else
            write(45,*)'</LesHouchesEvents>'
         endif
      endif

 303  format(7x,i10,1x,i8,1x,i4,1x,i4,1x,i4,1x,i4,1x,E16.9,1x,
     &     E16.9,1x,E16.9,1x,E16.9,1x,E16.9,1x,F2.0,1x,F2.0)


      return
      end
