ccc   initialises number of histograms
      subroutine inithist(nhist)
      integer nhist,i

      do i=1,nhist
         call histo3(i)
      enddo
 
      return
      end

ccc   binning subroutine
      subroutine binit(wt)
      implicit double precision(a-y)
      double precision pdec(4,4)
      integer i,ny
      double precision pcm(4),pboo1(4),pboo2(4),px(4),pn(4)

      include 'vars.f'
      include 'mom.f'
      include 'range.f'
      include 'proc.f'
      include 'decay.f'
      include 'pi.f'
      include 'x.f'
      include 'diss.f'
      include 'mp.f'
      include 'xb.f'
      include 'mq.f'
      include 'partonmom2.f'
      include 'pdfinf.f'
      include 'nhisterr.f'
      include 'wtarr.f'
      include 'ewpars.f'
    
ccccccccc
      
      call histo1(1,20,mmin,mmax,mx,wt,'mx')
      call histo1(2,30,ymin,ymax,yx,wt,'yx')
      
      if(SFerror)then
         do i=0,npdf
            call histo1(100+i,20,mmin,mmax,mx,wtarr(i),'mx')
            call histo1(200+i,30,ymin,ymax,yx,wtarr(i),'yx')
         enddo
      endif
      nhisterr=2
      
      return
      end


ccc   prints histograms
      subroutine histo1(ih,ib,x0,x1,x,w,labin)
      implicit real*8(a-h,o-z)
      character *(*) labin
      integer outl
      character*1 regel(30),blank,star
      dimension h(2000,100),hx(2000),io(2000),iu(2000),ii(2000)
      dimension y0(2000),y1(2000),ic(2000)
      data regel / 30*' ' /,blank /' ' /,star /'*'/
      double precision xarr(0:100),hp(20,100),hm(20,100)
      double precision barr(20)
      logical vbin
      dimension hmid(21)
cccc example of variable bin width binning (set vbin true to apply)
      data hmid /
     &     0.0,2.0,4.0,6.0,8.0,10.0,13.0,16.0,20.0,
     &     25.0,30.0,37.0,45.0,55.0,65.0,75.0,85.0,
     &     105.0,150.0,200.0,900.0/
      save
      
      include 'output.f'
      include 'iteration.f'
      include 'lab.f'
      include 'nhist.f'
      include 'pdfinf.f'

      vbin=.false.
      
      nbin=20
      
      do i=1,nbin
         barr(i)=hmid(i+1)-hmid(i)
      enddo

      if(nhist.lt.ih)nhist=ih

      lab(ih)=labin

      call length(labin,outl)

      y0(ih)=x0
      y1(ih)=x1
      ic(ih)=ib
      if(x.lt.x0) goto 11
      if(x.gt.x1) goto 12

cccc   default      
      ix=idint((x-x0)/(x1-x0)*dble(ib))+1
cccccccvariable bin
      if(vbin)then
      do i=1,nbin+1
         if(x.gt.hmid(i).and.x.lt.hmid(i+1))ix=i
      enddo
      endif
      
      h(ih,ix)=h(ih,ix)+w
      if(h(ih,ix).gt.hx(ih)) hx(ih)=h(ih,ix)
      ii(ih)=ii(ih)+1

         
      return
   11 iu(ih)=iu(ih)+1
      return
   12 io(ih)=io(ih)+1
      return
      entry histo2(ih,il)

      call length(outtag,outl)
      open(10,file='outputs/output'//outtag(1:outl)//'.dat',
     &     Access='append',Status='old')

       call length(lab(ih),outl)
     

      ib1=ic(ih)
      x01=y0(ih)
      x11=y1(ih)
      bsize=(x11-x01)/dble(ib1)
      hx(ih)=hx(ih)*(1.d0+1.d-06)

      if(SFerror)then
         do iv=1,ib1
            do j=0,npdf
c               xarr(j)=h(ih+j+99,iv)
               xarr(j)=h(100*ih+j,iv)
c               print*,iv,j,xarr(j)/bsize/dble(it)
            enddo
            call PDFerror(xarr,xs0,xsp,xsm)
            xs0=xs0*dble(it)
            xsp=xsp*dble(it)
            xsm=xsm*dble(it)
            hp(ih,iv)=xs0+xsp
            hm(ih,iv)=xs0-xsm
c            print*,xs0/bsize/dble(it),xsp/bsize/dble(it)
c     &           ,xsm/bsize/dble(it),h(ih,iv)/bsize/dble(it)
         enddo
      endif

      
      write(6,*)''
      write(6,*)'***************************************'
      write(6,*)lab(ih)(1:outl)
      write(6,*)'***************************************'
      write(6,21)ii(ih),iu(ih),io(ih)
      write(6,*)'***************************************'
      
   21 format(' inside,under,over : ',3i6)
  
      if(ii(ih).eq.0) goto 28
      if(SFerror)then
         write(6,123)
      else
         write(6,23)
      endif
 23   format(35(1h ),3(10h----+----i))
 123  format(66(1h ),3(10h----+----i))
      do 27 iv=1,ib1
ccccc default         
         z=(dble(iv)-0.5d0)/dble(ib1)*(x11-x01)+x01
         zl=(dble(iv)-1d0)/dble(ib1)*(x11-x01)+x01
         zh=(dble(iv))/dble(ib1)*(x11-x01)+x01
ccccccvariable bin
         if(vbin)then
         z=(hmid(iv+1)+hmid(iv))/2d0
         zl=hmid(iv)
         zh=hmid(iv+1)
         bsize=barr(iv)
         endif
      if(il.eq.1) goto 24
      iz=idint(h(ih,iv)/hx(ih)*30.)+1
      goto 25
   24 iz=-1
      if(h(ih,iv).gt.0.d0)
     .iz=idint(dlog(h(ih,iv))/dlog(hx(ih))*30.)+1
   25 if(iz.gt.0.and.iz.le.30) regel(iz)=star
      h(ih,iv)=h(ih,iv)
      if(SFerror)then
         write(6,126)z,h(ih,iv)/bsize/dble(it),hp(ih,iv)/bsize/dble(it)
     &        ,hm(ih,iv)/bsize/dble(it),(regel(i),i=1,30)         
      else
         write(6,26) z,h(ih,iv)/bsize/dble(it),(regel(i),i=1,30)
      endif
      if(SFerror)then
         write(10,*)z,zl,zh,h(ih,iv)/bsize/dble(it)
     &        ,hp(ih,iv)/bsize/dble(it),hm(ih,iv)/bsize/dble(it)         
      else
         write(10,*)z,zl,zh,h(ih,iv)/bsize/dble(it)
      endif

  126 format(2g15.6,' ',g15.6,' ',g15.6,4h   i,30a1,1hi)
   26 format(1h ,2g15.6,4h   i,30a1,1hi)
      if(iz.gt.0.and.iz.le.30) regel(iz)=blank
   27 continue
      if(SFerror)then
         write(6,123)
      else
         write(6,23)
      endif

      write(10,*)
      close(10)

      return
   28 write(6,29)
   29 format('  no entries inside histogram')

      return

      entry histo3(ih)
      do 31 i=1,100
   31 h(ih,i)=0.
      hx(ih)=0.
      io(ih)=0
      iu(ih)=0
      ii(ih)=0
      return 
      end

